
P286
DOSSEG
MODEL SMALL
STACK	200h

DATASEG

VidAct	EQU	00000010b
DskAct	EQU	00000100b
F10Push	EQU	00001000b
KbdAct	EQU	00010000b
Idle	EQU	00100000b

RShift	EQU	00000001b
LShift	EQU	00000010b
Cntrol	EQU	00000100b
AltKey	EQU	00001000b
ScrlLc	EQU	00010000b
NumLoc	EQU	00100000b
CapsLc	EQU	01000000b
InstLc	EQU	10000000b

_Up	EQU	00000001b
_Down	EQU	00000010b
_Left	EQU	00000100b
_Right 	EQU	00001000b
_DblVer	EQU	00010000b
_DblHor	EQU	00100000b

_Draw	EQU	00000001b
	
MAX	EQU	32767
MARK	EQU	254

; Returns an address of the previous line in ES:DI 
; Input : DI = a position within the current line
; ES = segment address of the buffer
; Destroys FLAGS,CX,AX
PrevLine	MACRO
	std
	mov	al,10
	mov	cx,-1
repne	scasb
repne	scasb
	inc	di
	inc	di
ENDM


; Returns an address of the next line in ES:DI
; Input : DI a position within the current line
; ES = segment address of the buffer
; Destroys FLAGS,CX,AX
NextLine	MACRO
	SKIP	-1,,ds,13
	inc	di
ENDM


Copyright	DB	'(C) 1994 Musa Maharramov',10,13,'$'
ErrAdapt	DB	'Error: EGA or VGA required',10,13,'$'
GenIOErr	DB	'I/O error occured.Strike a key$'
ModTxt		DB	'Text has been modified. Save (Y/N)? $'
LdPrmpt		DB	'Enter a file name: $'
Noname		DB	'NONAME.TXT',0
Header		DB	'Edit:'
; contains a file name
InpBuff	DB	20
	DB	0
FName	DB	20	dup(0)
	DB	'             '
__Draw	DB	' '
	DB	'Line       Col       $'

Tabl	DB	0,25,24,'',26,'ٿ',27,''
	DB	0,31,30,'',00,'',00,''
TabMid	DB	''
	DB	0,25,24,'',16,'',17,''
	DB	0,31,30,'',00,'',00,''
TabEnd	DB	''

Sym	dB	0
PrevSym	DW	?
Status	DB	0

UDATASEG

; a pointer to the file end
EndF	DW	?

; current position
Current	DW	?

; file size
Lngth	DW	?

; total lines number
Lines	DW	?

; current line and column
CurLine	DW	?
Col	DW	?

; top line
TopLine	DW	?

; file handle
Handle	DW	?

; screen's top line address
Top	DW	?

; determines whether to refresh the screen
RePaint	DB	?


; Text margin
Margin	DW	?

; cursor positions
Row	DB	?
Column	DB	?

; Block data
MarkBl	DB	?
StartL	DW	?
EndL	DW	?
BeginBl	DW	?
EndBl	DW	?

; was the file saved
Saved	DB	?

; prepare for the next step
Prep	DB	?

; the editting buffer
	DB	?
	DB	?
Buffer	DB	MAX+5	dup(?)


CODESEG
	STARTUPCODE
   ;Release all memory except the amount currently being used
   ;End of stack is end of non-heap portion of program
   MOV BX,SP
   ADD BX,15    ;convert SP into paragraphs
   SHR BX,4
   MOV AX,SS    ;calculate size of program using ES PSP address
   ADD BX,AX
   MOV AX,ES
   SUB BX,AX
   MOV AH,4AH   ;resize memory block with PSP
   INT 21H      ;address in ES

	jmp Strt

; Case jump table
Case	STRUC
KEY	DW	0
JUMP	DW	0
Case	ENDS

Cases	LABEL	CASE
	Case {Key=KeyUp,Jump=OFFSET Up} 
	Case {Key=KeyDown, Jump=OFFSET Down}
	Case {Key=KeyEsc, Jump=OFFSET EscL}
	Case {Key=KeyEnter,Jump=OFFSET EnterL}
	Case {Key=KeyLeft,Jump=OFFSET Left}
	Case {Key=KeyRight,Jump=OFFSET Right}
	Case {Key=KeyDel,Jump=OFFSET  Delete}
	Case {Key=KeyBackspace,Jump=OFFSET Backspace}
	Case {Key=KeyF3,Jump=OFFSET F3}
	Case {Key=KeyShF3,Jump=OFFSET ShiftF3}
	Case {Key=KeyPgUp,Jump=OFFSET PgUp}
	Case {Key=KeyPgDn,Jump=OFFSET PgDn}
	Case {Key=KeyF4,Jump=OFFSET F4}
	Case {Key=KeyF2,Jump=OFFSET F2}
	Case {Key=KeyF5,Jump=OFFSET F5}
	Case {Key=KeyF8,Jump=OFFSET F8}
	Case {Key=KeyHome,Jump=OFFSET Home}
	Case {Key=KeyEnd,Jump=OFFSET EndK}
	Case {Key=KeyTab,Jump=OFFSET Tab}
	Case {Key=KeyF9,Jump=OFFSET F9}
	Case {Key=3100h,Jump=OFFSET Alt_N}
	Case {Key=KeyShF2,Jump=OFFSET SaveAs}
	Case {Key=KeyF1,Jump=DrawTabl}
	Case {}

Marker	DB	'>','<'
; Text attribute
Attr	DB	31,14+16*2,48,58

INCLUDE		MACR.INC

InsBl	PROC	PASCAL	NEAR
ARG	Count:WORD
USES	ES
	mov	bx,ds
	mov	es,bx
	mov	bx,Count
	cmp	MarkBl,0
	je	Copy1
	mov	di,Current
	cmp	di,BeginBl
	jae	TestEnd1
	add	BeginBl,bx
TestEnd1:
	cmp	di,EndBl
	jae	Copy1
	add	EndBl,bx
Copy1:
	add	Lngth,bx
	mov	si,EndF
	mov	di,si
	add	di,bx
	mov	cx,si
	sub	cx,Current
	inc	cx
	mov	EndF,di
	std
rep	movsb
	mov	Saved,0
	ret
InsBl	ENDP


DelBl	PROC	PASCAL	NEAR
ARG	Count:WORD
USES	ES
	mov	ax,ds
	mov	es,ax
	mov	ax,Count

	cmp	MarkBl,0
	je	Copy
	mov	di,Current
	cmp	di,BeginBl
	jae	TestEnd
	sub	BeginBl,ax
TestEnd:
	cmp	di,EndBl
	jae	Copy
	sub	EndBl,ax
Copy:
	mov	cx,EndF
	sub	Lngth,ax
	sub	EndF,ax
	mov	di,Current
	mov	si,di
	add	si,ax
	sub	cx,si
	cld
rep	movsb
	mov	Saved,0
	ret
DelBl	ENDP

GetReply	PROC	PASCAL	NEAR
ARG	Prmpt:NEAR PTR
	mov	dx,Prmpt
	mov	ah,09h
	int	21h

	mov	ah,08h
	int	21h

	cmp	al,27
	jne	GR
	mov	al,0
	jmp	short	GSL
GR:	cmp	al,'y'
	jne	GTL
	mov	al,1
	jmp	short	GSL
GTL:
	cmp	al,'Y'
	jne	GSL
	mov	al,1
GSL:
	ret
GetReply	ENDP

IdleScr	PROC	NEAR
	pusha
	mov	ax,SCREEN_SEG
	mov	es,ax
	mov	di,160
	mov	cx,80*24
	xor	ax,ax
	cld
rep	stosw
	popa
	ret
IdleScr	ENDP

PutDec	PROC	PASCAL	NEAR
USES	ES
	mov	bx,SCREEN_SEG
	mov	es,bx

	mov	cx,5
	mov	bx,10
	xor	dx,dx

OutN:
	div	bx
	and	ax,ax
	jnz	PutDigit
	and	dx,dx
	jnz	PutDigit
	mov	dl,' '
	jmp	lp
PutDigit:
	xor	dl,'0'
lp:		
	mov	BYTE PTR es:[di],dl
	dec	di
	dec	di
	xor	dx,dx
	loop	OutN
	ret
PutDec	ENDP

FindSym	PROC	NEAR
	push	es
	mov	cx,ds
	mov	es,cx
	mov	bx,OFFSET Tabl

	mov	di,OFFSET TabMid
	mov	cx,32
	std
repne	scasb
	je	UJK

	mov	di,OFFSET TabEnd
	mov	cx,32
repne	scasb

UJK:
	inc	di
	sub	di,bx
	mov	bx,di
	pop	es
	ret
FindSym	ENDP

PutTbl	PROC	PASCAL	NEAR
ARG	MainOp:NEAR PTR
	inc	Prep
	call	PutBord
	jc	Crash
	mov	ax,Col
	push	ax
	call	MainOp
	pop	ax
	test	sym,_Up OR _Down
	jz	PPO
	cmp	ax,Col
	je	PPO
	mov	cx,ax
	sub	cx,Col
Blanks:
	push	cx
	mov	al,' '
	call	Char
	pop	cx
	loop	Blanks
PPO:
	mov	si,Current
	mov	al,[si]
	cmp	al,13
	je	NoBr
	call	FindSym
	test	Sym,(_Left OR _Right)
	jnz	NoHor
	and	bl,not _DblVer
	jmp	short	TYUI
NoHor:	and	bl,not _DblHor
TYUI:	or	sym,bl
	test	cs:_Shift,InstLc
	jz	Nobr
	call	Delete
NoBr:
	xor	bx,bx
	mov	bl,sym
	mov	al,Tabl[bx]
	call	Char
	call	Left
	dec	Prep
	ret
Crash:
	mov	ah,2
	mov	dl,7
	int	21h
	ret
PutTbl	ENDP


PutBord	PROC	NEAR
	mov	si,PrevSym
	mov	al,[si]
	cmp	al,13
	je	ErrTab
	call	FindSym

	mov	dl,sym
	and	dl,_Left
	shl	dl,1
	or	bl,dl
	mov	dl,sym
	and	dl,_Right
	shr	dl,1
	or	bl,dl
	
	mov	dl,sym
	and	dl,_Up
	shl	dl,1
	or	bl,dl
	mov	dl,sym
	and	dl,_Down
	shr	dl,1
	or	bl,dl

	mov	dl,sym
	test	dl,_Left OR _Right
	jz 	LKI
	and	dl,_DblHor
	and	bl,not _DblHor
	or	bl,dl
LKI:
	mov	dl,sym
	test	dl,_Up OR _Down
	jz	RTQ
	and	dl,_DblVer
	and	bl,not _Dblver
	or	bl,dl
RTQ:
	mov	al,Tabl[bx]
	mov	[si],al
NoCnct:
	clc
	ret
ErrTab:
	mov	al,' '
	call	Char
	call	Left
	clc
	ret
PutBord	ENDP	

; Critical Error handler
CritErr	PROC	NEAR
	mov	al,2
	iret
CritErr	ENDP

; CNTRL+BREAK handler 
NewBreak	PROC	FAR
	xor	cs:Flgs,1
	iret
NewBreak	ENDP

_ch	DB	?
_Shift	DB	0

NewKbd	PROC	FAR
	cli
	push	ax
	in	al,60h
	jmp	short	$+2
	mov	cs:[_ch],al

	push	es
	xor	ax,ax
	mov	es,ax

	mov	al,cs:_Shift
	xor	al,es:[417h]
	jz	NotToggled
	
	mov	al,es:[417h]
	mov	cs:_Shift,al
	test	al,InstLc

	mov	ax,SCREEN_SEG
	mov	es,ax

	jz	OvrWr
	mov	ah,cs:Attr[2]
	mov	al,'I'
	jmp	ShowStatus
OvrWr:
	mov	ah,cs:Attr[1]
	mov	al,'O'
ShowStatus:
	mov	WORD PTR es:[36],ax
NotToggled:
	pop	es
	pop	ax
	sti
	pushf
	call	cs:[OldKbd]
	test	cs:Flgs,(KbdAct OR DskAct OR VidAct)
	jnz	Ex_kbd
	or	cs:Flgs,KbdAct
	mov	cs:Ticks,91
	push	ax
	mov	ax,cs:Gap
	mov	cs:Secs,ax
	pop	ax

	test	cs:Flgs,Idle
	jz	Untouch
	
	pusha
	call	enable_video
	popa
	
	and	cs:Flgs,(not Idle)

Untouch:
	cmp	cs:[_ch],44h	; is F10 pushed?
	jne	NoF10
	or	cs:Flgs,F10Push
NoF10:
	xor	cs:Flgs,KbdAct
Ex_kbd:
	iret
NewKbd	ENDP


NewVideo	PROC	FAR
	or	cs:Flgs,VidAct
	pushf
	call	cs:[OldVideo]
	xor	cs:Flgs,VidAct
	iret
NewVideo	ENDP

NewDisk	PROC	FAR
	or	cs:Flgs,DskAct
	pushf
	call	cs:[OldDisk]
	xor	cs:Flgs,DskAct
	ret	2
NewDisk	ENDP


; Timer interrupt handler
NewTimer	PROC	FAR
	pushf
	call	cs:OldTimer

	test	cs:Flgs,(KbdAct OR DskAct OR VidAct) 	; hardware active - exit
	jnz	Exit_tim

	test	cs:Flgs,F10Push
	jnz	Exit_prg

	dec	cs:Ticks
	jnz	Exit_tim

	mov	cs:Ticks,91
	sub	cs:Secs,5

	jnz	Exit_tim

	mov	cs:Ticks,1
	add	cs:Secs,5

	test	cs:Flgs,Idle
	jnz	Exit_tim
	or	cs:Flgs,Idle

	pusha
	call	disable_video
	popa
	jmp	short	Exit_tim

Exit_prg:
	push	bp		; exit the program
	mov	bp,sp
	mov	WORD PTR [bp+2],offset ByeBye
	mov	WORD PTR [bp+4],seg ByeBye
	pop	bp
Exit_tim:
	iret
NewTimer	ENDP

KbdBreak	PROC	FAR
	iret
KbdBreak	ENDP


OLDCrit		DD	?
OLDDosBr	DD	?
OLDBioBr	DD	?
OldTimer	DD	?
OldKbd		DD	?
OldVideo	DD	?
OldDisk		DD	?
Flgs		DB	0
Ticks		DB	18
Secs		DW	20
Gap		DW	20
ac_addr		DW	?	; attribute controller address for EGA/VGA

; returns al = 0(MDA), 1(CGA), or 2(EGA/VGA)
video_id	PROC	NEAR
	mov	ah,12h
	mov	bl,10h
	int	10h
	mov	al,2
	cmp	bl,10h
	jne	video_exit
	dec	al
	mov	bx,40h
	mov	es,bx
	test	byte ptr es:[63h],40h
	jnz	video_exit
	dec	al
video_exit:	
	ret
video_id	ENDP
	
disable_video	PROC	NEAR
	cli
	mov	dx,cs:[ac_addr]
	in	al,dx
	jmp	short	$+2
	xor	al,al
	mov	dx,3C0h
	out	dx,al
	jmp	short	$+2
	mov	dx,cs:[ac_addr]
	in	al,dx
	sti
	ret
disable_video	ENDP

enable_video	PROC	NEAR
	cli
	mov	dx,cs:[ac_addr]
	in	al,dx
	jmp	short	$+2
	mov	al,20h
	mov	dx,3C0h
	out	dx,al
	jmp	short	$+2
	mov	dx,cs:[ac_addr]
	in	al,dx
	sti
	ret
enable_video	ENDP
	

; here starts the program
Strt:
	ShowStr	<OFFSET Copyright>

	call	video_id
	cmp	al,2
	je	Go_On
	lea	dx,ErrAdapt
	jmp	ErrOcc
Go_On:
	mov	Prep,0	; no preparation yet

;redefine critical error routine
	GetVec	1Bh
	mov	WORD PTR cs:OLDBioBr[0],bx
	mov	WORD PTR cs:OLDBioBr[2],es
	call	SetVector PASCAL,1Bh, cs OFFSET KbdBreak

	GetVec	23h
	mov	WORD PTR cs:OLDDosBr[0],bx
	mov	WORD PTR cs:OLDDosBr[2],es
	call	SetVector PASCAL,23h, cs OFFSET KbdBreak


	GetVec	DOS_CRITERR
	mov	WORD PTR cs:OLDCrit[0],bx
	mov	WORD PTR cs:OLDCrit[2],es
	call	SetVector PASCAL,DOS_CRITERR,cs OFFSET CritErr


	GetVec	10h
	mov	WORD PTR cs:OLDVideo[0],bx
	mov	WORD PTR cs:OLDVideo[2],es
	call 	SetVector PASCAL,10h,cs OFFSET NewVideo


	GetVec	13h
	mov	WORD PTR cs:OLDDisk[0],bx
	mov	WORD PTR cs:OLDDisk[2],es
	call 	SetVector PASCAL,13h,cs OFFSET NewDisk


	GetVec	TIMER
	mov	WORD PTR cs:OLDTimer[0],bx
	mov	WORD PTR cs:OLDTimer[2],es
	call	SetVector PASCAL,TIMER,cs OFFSET NewTimer

	GetVec	09h
	mov	WORD PTR cs:OLDKbd[0],bx
	mov	WORD PTR cs:OLDKbd[2],es
	call	SetVector PASCAL,09h,cs OFFSET NewKbd

; determine the attribute controller address for EGA/VGA
	mov	ax,40h
	mov	es,ax
	or	BYTE PTR es:[17h],InstLc	; insert locked
	pushf
	int	09h
	mov	ax,es:[63h]
	add	ax,6
	mov	ac_addr,ax

	mov	ah,62h	; get PSP address
	int	21h

	mov	es,bx
	cmp	BYTE PTR es:[80h],0
	je	EnterName
	
	xor	cx,cx	; browse command line
	mov	cl,BYTE PTR es:[80h]
	mov	al,' '
	mov	di,81h
repe	scasb
	jcxz	EnterName
	mov	si,OFFSET FNAME
	dec	di
	inc	cx
CopyFName:
	mov	al,es:[di]
	mov	[si],al
	inc	si
	inc	di
	loop	CopyFName
	mov	BYTE PTR [si],0	; put a filename terminator
	jmp	TryOpen

EnterName	LABEL	NEAR
	test	Prep,01
	jnz	CreateNoname
ReadFName:
	ScrollUp ,cs:Attr[2],00,00,00,79  
	SetCursor 0,0
	ShowStr	<OFFSET LdPrmpt>
	mov	InpBuff[0],20
	InputStrZ	<OFFSET InpBuff>,,0
	test	Prep,2
	jnz	TryCreate

TryOpen:
	lea	dx,FNAME
	Open	
	jnc	Begin
	jmp	short	TryCreate

CreateNoname:
	push	ds
	pop	es
	lea	di,FName
	lea	si,NoName
	cld
	mov	cx,11
rep	movsb
TryCreate:
	lea	dx,FName
	Create
	jnc	Begin
	SetCursor 0,0
	call	GetReply PASCAL,OFFSET GenIOErr
	jmp	ReadFName

Begin:
	mov	Handle,ax	; store a handle to the file
	mov	InpBuff[0],' '	; prepare header
	mov	InpBuff[1],' '
	test	Prep,2
	jz	NewFl
	retn
NewFl:
	call	ReadBlock PASCAL,Handle,MAX,DS OFFSET Buffer ; read the file into buffer
	jnc	ProcessFile	; if no error, process the file 
	mov	al,1
	jmp	ToDos	; to dos otherwise

ProcessFile:
;	ShortSeek	Handle,0,_END
	mov	Lngth,ax	; store the file length

	mov	si,OFFSET Buffer	; set a delimiter
	add	si,ax
	mov	WORD PTR [si],13+10*256
	inc	si
	mov	EndF,si
	mov	WORD PTR Buffer[-2],13+256*10	; put terminators 

	mov	Saved,1		; no changes made
	mov	Prep,0		; no complex operations


; clear the top line for header
	ScrollUp ,cs:Attr[2],00,00,00,79  

		
; Count the number of lines of the file
	mov	cx,Lngth	; cx <- file length

	mov	ax,ds	; es <- ds
	mov	es,ax
	mov	Lines,0
	mov	di,OFFSET Buffer	; di	 <- Buffer offset
CountL:
	SKIP	,,ds,13
	inc	Lines
	inc	cx
	loop	CountL

ShowFrSt:	; show from start
	mov	di,OFFSET BUFFER; di <- buffer offset
	mov	cs:_Shift,0	

	mov	MarkBl,0	; no marked blocks
	mov	BeginBl,-1	
	mov	EndBl,0

	mov	RePaint,1	; refresh display
	mov	Current,di	; Current <- Buffer Offset
	mov	Top,di		; Top	 <- Buffer offset
	mov	TopLine,1
	mov	Row,1
	mov	Column,0
	mov	CurLine,1
	mov	Col,0
	mov	Margin,0

PutHeader:
	SetCursor 0,0
	ShowStr	<OFFSET Header>

	jmp	StCur	

ShowTxt:
; upon the entry to this block ES contains seg address of Buffer

	mov	di,Top	; DS:DI <- Top line
	xor	bx,bx
	mov	dx,TopLine

LineOut:
	cmp	Margin,0
	je	PtLines
	SKIP	Margin,,ds,13
	jne	PtLines
	dec	di
PtLines:
	mov	cx,80
RdCh:
	mov	ah,attr[bx]
	mov	al,[di]
	test	MarkBl,10b
	jz	PtCh
	cmp	di,BeginBl
	jb	PtCh
	cmp	di,EndBl
	jae	PtCh
	xor	bx,10b
PtCh:
	cmp	al,MARK
	jne	HJ
	xor	bx,1
	mov	al,cs:Marker[bx]
	test	bx,1
	jnz	L
HJ:
	mov	ah,cs:attr[bx]
L:	and	bl,11111101b	; remove marking
	cmp	al,13
	jne	Outy
	mov	al,' '
	jmp	PPT
Outy:	inc	di
PPT:	mov	es:[si],ax
	inc	si
	inc	si
	loop	RdCh
	
	cmp	dx,Lines
	je	C
	SKIP	-1,,ds,10
	inc	dx
C:	cmp	si,160*25
	je	PollKbd
	jmp	LineOut
	
PollKbd:	
; waits Keyboard Input

	mov	ah,00h	; reads keyboard input
	int	16h
	
	lea	di,Cases
Scan:
	mov	bx,cs:[di.Key]	; scan case table
	cmp	bx,ax
	je	SelectCase
	and	bx,bx
	jnz	NxtCase
	and	al,al
	jz	PollKbd
	jmp	Char
NxtCase:
	add	di, SIZE Case
	jmp	short Scan

SelectCase:
	mov	bx,ds	; es <- Buffer segment
	mov	es,bx
	mov	bx,cs:[di.Jump]
	mov	di,Current
	jmp	bx

Up	LABEL	NEAR

	cmp	Prep,0
	jne	NoTabl1
	test	cs:Status,_Draw
	jz	NoTabl1
	mov	si,Current
	mov	PrevSym,si
	mov	sym,_Down
	test	cs:_Shift,CapsLc
	jz	PutTab1
	or	sym,_DblVer 
PutTab1:
	call	PutTbl PASCAL, OFFSET Up
	jmp	StCur
NoTabl1:
	cmp	Row,1
	je	ScrUp
	dec	Row
	jmp	UpLine
ScrUp:
	cmp	TopLine,1
	jne	ShiftScr
	jmp	StCur
ShiftScr:
	mov	di,Top
	PrevLine
	dec	TopLine
	mov	Top,di
	inc	RePaint
UpLine:
	dec	CurLine
	mov	di,Current
	PrevLine
	jmp	PutLine

Down	LABEL	NEAR
	cmp	Prep,0
	jne	NoTabl2
	test	cs:Status,_Draw
	jz	NoTabl2
	mov	si,Current
	mov	PrevSym,si
	mov	sym,_Up
	test	cs:_Shift,CapsLc
	jz	PutTab2
	or	sym,_DblVer
PutTab2:
	call	PutTbl PASCAL,OFFSET Down
	jmp	StCur
NoTabl2:

	mov	ax,CurLine
	cmp	ax,Lines
	jb	IsnotLast
	jmp	StCur
IsnotLast:
	cmp	Row,24
	je	ScrDown
	inc	Row
	jmp	DownLine
ScrDown:
	inc	TopLine
	mov	di,Top
	NextLine
	mov	Top,di
	inc	RePaint

DownLine:
	inc	CurLine
	mov	di,Current
	NextLine
PutLine:
	xor	cx,cx
	mov	cl,Column
	cmp	cl,0
	jne	C1
	cmp	Margin,0
	je	Ok1
	jmp	short	AdjustMargin
C1:	SKIP	,,ds,13
	jne	AdjustMargin
	inc	cl
	sub	Column,cl
	dec	di
	cmp	Margin,0
	je	Ok1

AdjustMargin:
	SKIP	Margin,,ds,13
	jne	Ok1
	inc	cx
	dec	di
	inc	RePaint
	sub	Margin,cx
Ok1:	mov	Current,di

StCur:
	xor	ax,ax	; calculate current column number
	mov	al,Column
	add	ax,Margin
	mov	Col,ax

	cmp	Prep,0
	je	GoOn
	retn
GoOn:
	mov	ax,SCREEN_SEG
	mov	es,ax
	mov	si,160

	SetCursor	Column,Row
	mov	al,' '
	cmp	Saved,1
	je	Untouched
	mov	al,'!'
Untouched:
	mov	es:[78],al

	mov	di,98
	mov	ax,CurLine
	call	PutDec

; put column number

	mov	di,118
	mov	ax,Col
	inc	ax
	call	PutDec

	mov	di,138
	mov	ax,Lines
	call	PutDec

	mov	ax,Lngth
	mov	di,158
	call	PutDec	

	cmp	RePaint,0
	jne	ReDraw
	jmp	PollKbd
ReDraw:	mov	RePaint,0
	jmp	ShowTxt

Left	LABEL	NEAR
	cmp	Prep,0
	jne	NoTabl
	test	cs:Status,_Draw
	jz	NoTabl
	mov	si,Current
	mov	PrevSym,si
	mov	sym,_Right
	test	cs:_Shift,CapsLc
	jz	PutTab
	or	sym,_DblHor
PutTab:
	call	PutTbl PASCAL,OFFSET Left
	jmp	StCur
NoTabl:
	cmp	Column,0
	je	ShiftMargin
	dec	Column
	dec	Current
	jmp	StCur
ShiftMargin:
	cmp	Margin,0
	je	ToPrev
	dec	Margin
	dec	Current
	inc	RePaint
	jmp	StCur
ToPrev:
	cmp	di,OFFSET BUFFER
	jne	PrevL
	jmp	StCur
PrevL:
	mov	Margin,-1
	mov	Column,79
	inc	RePaint
	jmp	Up

Right	LABEL	NEAR
	cmp	Prep,0
	jne	NoTabl3
	test	cs:Status,_Draw
	jz	NoTabl3
	mov	si,Current
	mov	PrevSym,si
	mov	sym,_Left
	test	cs:_Shift,CapsLc
	jz	PutTab3
	or	sym,_DblHor
PutTab3:
	call	PutTbl PASCAL,OFFSET Right
	jmp	StCur
NoTabl3:
	cmp	BYTE PTR es:[di],13
	je	ToNext
	inc	Current
	cmp	Column,79
	je	ShiftMargin2
	inc	Column
	jmp	StCur
ShiftMargin2:
	add	Margin,1
	inc	RePaint
UUI:	jmp	StCur
ToNext:
	mov	Margin,0
	mov	Column,0
	inc	RePaint
	jmp	Down

Backspace:
	inc	Prep
	Call	Left
	dec	Prep
	mov	di,Current
	cmp	di,OFFSET Buffer
	jne	DelChar
	jmp	StCur
DelChar:
	jmp	Delete

Char	LABEL	NEAR
	cmp	Lngth,MAX
	jb	NewChar

Overflow:
	mov	dl,07	; bell
	mov	ah,02h
	int	21h
	jmp	StCur

NewChar:
	push	ax
	test	cs:_Shift,InstLc
	jnz	InsChar
	mov	si,Current
	cmp	BYTE PTR [si],13
	je	InsChar
	jmp	short	OvrChar
InsChar:	
	CALL	InsBl PASCAL,1
OvrChar:
	inc	RePaint
	mov	di,Current
	pop	ax
	mov	[di],al
Ord:	mov	bx,ds
	mov	es,bx
	inc	Prep
	call	Right
	dec	Prep
	jmp	StCur

Tab:
	inc	Prep
PutBlank:
	mov	al,' '
	call	Char
	mov	ax,Col
	xor	dx,dx
	mov	bx,8
	div	bx
	and	dx,dx
	jnz	PutBlank
	dec	Prep
	jmp	StCur

EnterL:
	test	cs:_Shift,InstLc
	jz	OvrLine
	CALL	InsBl PASCAL,1
	mov	di,Current
	mov	BYTE PTR [di],10
	inc	Lines
	mov	al,13
	jmp	Char
OvrLine:
	inc	Prep
	call	Home
	call	Down
	dec	Prep
	jmp	StCur

Delete:
	mov	ax,EndF
	dec	ax
	cmp	Current,ax
	je	ByPass
	inc	RePaint
	CALL    DelBl PASCAL,1
	mov	di,Current
	cmp	BYTE PTR [di],10
	jne	ByPass
	CALL	DelBl PASCAL,1
	dec	Lines
ByPass:
	jmp	StCur
	
F3:	
	mov	di,Current
	test	MarkBl,1
	jz	NoEnd
	cmp	di,EndBl
	jb	PutM
	and	MarkBl,0
	jmp	short	NoEnd
PutM:
	or	MarkBl,10b
NoEnd:
	mov	bx,CurLine
	mov	StartL,bx
	mov	BeginBl,di
OKB:
	or	MarkBl,1
	inc	RePaint
NotMark:
	jmp	StCur

F4:	
	mov	di,Current
	test	MarkBl,1
	jz	NoBeg
	cmp	di,BeginBl
	ja	PutMk
	and	MarkBl,0
	jmp	short	NoBeg
PutMk:
	or	MarkBl,10b
NoBeg:
	mov	bx,CurLine
	mov	EndL,bx
	mov	EndBl,di
	jmp	short OKB

ShiftF3:
	cmp	MarkBl,0
	je	NoBlock
	mov	MarkBl,0
	mov	BeginBl,-1
	mov	EndBl,0
	inc	RePaint
NoBlock:
	jmp	StCur

PgUp:
	inc	Prep
	mov	cx,24
PagesUp:
	pusha
	Call	Up
	popa
	loop	PagesUp
	dec	Prep
	jmp	StCur

PgDn:
	inc	Prep
	mov	cx,24
PagesDn:
	pusha
	Call	Down
	popa
	loop	PagesDn
	dec	Prep
	jmp	StCur

F5:
	cmp	MarkBl,0
	jne	TstBl
NCop:	jmp	StCur
TstBl:
	mov	di,Current
	cmp	di,BeginBl
	jb	CpBl
	cmp	di,EndBl
	jae	CpBl
	jmp	short	NCop

CpBl:
	mov	cx,EndBl
	sub	cx,BeginBl
	mov	ax,Lngth
	add	ax,cx
	cmp	ax,MAX
	jb	MakeCopy
	jmp	Overflow
MakeCopy:
	push	es
	mov	ax,ds
	mov	es,ax

	inc	RePaint

	push	cx
	CALL	InsBl PASCAL,cx
	pop	cx

	mov	si,BeginBl
	mov	di,Current
	cld
rep	movsb	
	pop	es
	mov	ax,EndL
	sub	ax,StartL
	add	Lines,ax
	mov	Saved,0
	jmp	StCur

F2	LABEL	NEAR
	SetCursor	0,0
	ShortSeek	Handle,0,_START
	jc	FErr
	call	WriteBlock	PASCAL,	Handle,Lngth,DS OFFSET Buffer
	jc	FErr
	Truncate	Handle
	jnc	OkSave
FErr:	
	mov	ah,02h
	mov	dl,07h
	int	21h
	jmp	ReFr
OkSave:
	mov	Saved,1
NoBl:	jmp	StCur
ReFr:
	mov	ah,00h	; wait a key
	int	16h
	jmp	PutHeader

F8	LABEL	NEAR
	cmp	MarkBl,0
	je	NoBl
	mov	di,BeginBl
	mov	Current,di
	mov	di,BeginBl
	sub	EndBl,di
	CALL	DelBl	PASCAL,EndBl
	mov	MarkBl,0
	mov	ax,EndL
	sub	ax,StartL
	sub	Lines,ax
	mov	Saved,0
No_Act:	mov	Prep,0
	jmp	ShowFrSt


F9	LABEL	NEAR
	test	Saved,1
	jnz	Ld_Fl
	SetCursor 0,0
	call	GetReply PASCAL,OFFSET ModTxt
	cmp	al,0
	je	No_Act
	cmp	al,1
	jne	Ld_Fl
	inc	Prep
	call	F2
	dec	Prep
Ld_Fl:	
	Close	Handle
	SetCursor	0,0
	ScrollUp ,cs:Attr[2],0,0,0,79
	ShowStr	<OFFSET LdPrmpt>
	jmp	EnterName

Alt_N	LABEL	NEAR
	inc	Prep
	jmp	short	F9

SaveAs	LABEL	NEAR
	Close	Handle
	mov	Prep,2
	call	EnterName
	mov	Prep,0
	inc	Prep
	call	F2
	dec	Prep
	jmp	No_Act

DrawTabl:
	xor	Status,_Draw
	jmp	short	UIO
Home:
	inc	Prep
MvLeft:
	cmp	Col,0
	je	Moved
	Call	Left
	jmp	short	MvLeft
Moved:
	dec	Prep
UIO:	jmp	StCur

EndK:
	inc	Prep
MvRight:
	mov	di,Current
	cmp	BYTE PTR [di],13
	je	Mvd
	Call	Right
	jmp	short	MvRight
Mvd:
	dec	Prep
	jmp	StCur

EscL:
	cmp	Saved,1
	je	ByeBye
	SetCursor 0,0
	call	GetReply PASCAL,OFFSET ModTxt
	cmp	al,0
	jne	ExT
	jmp	PutHeader
ExT:
	cmp	al,1
	jne	ByeBye
	inc	Prep
	CALL	F2
Ex:
ByeBye:
	ScrollUp	,07,0,0,24,79
	xor	ax,ax		; no error
	jmp	short	ToDos
ErrOcc:
	ScrollUp	,07,0,0,24,79
	mov	ah,9h
	int	21h
	mov	al,1
ToDos:	
	push	ax
	call 	SetVector	PASCAL,DOS_CRITERR,cs:OLDCrit
	call	SetVector	PASCAL,TIMER,	cs:OLDTimer
	call	SetVector	PASCAL,09h,	cs:OLDKbd
	call	SetVector	PASCAL,10h,	cs:OLDVideo
	call	SetVector	PASCAL,13h,	cs:OLDDisk
	call	SetVector	PASCAL,1Bh,	cs:OLDBioBr
	call	SetVector	PASCAL,23h,	cs:OLDDosBr
	Close	Handle
	pop	ax
	EXITCODE
END


